import { Effects, Commands, BlockLocation, Location, World} from "Minecraft";
import * as Minecraft from 'Minecraft';
import { Juaneitor } from "scripts/juan/functions/juaneitor.js";
var allowWaiso = true;
Minecraft.World.events.beforeChat.subscribe((eventData) => {
	const eventMessage = eventData.message.split(` `);
	if(eventMessage == "hideWaiso"){
		if(allowWaiso == true){
		allowWaiso = false;
		Minecraft.Commands.run(`tellraw @a {"rawtext": [{ "text": "§eHided WAISO for all players" } ] }`);
		eventData.canceled = true;
		}else{
			Minecraft.Commands.run(`tellraw @a {"rawtext": [{ "text": "§WAISO is already hided" } ] }`);
			eventData.canceled = true;
		}
	}else if(eventMessage == "showWaiso"){
		if(allowWaiso == false){
		allowWaiso = true;
		Minecraft.Commands.run(`tellraw @a {"rawtext": [{ "text": "§WAISO was enabled for all players" } ] }`);
		eventData.canceled = true;
		}else{
			Commands.run(`tellraw @a {"rawtext": [{ "text": "§4WAISO is already enabled" } ] }`);
			eventData.canceled = true;
		}
	}
});

Minecraft.World.events.tick.subscribe(() => {
	if(allowWaiso== true){
	try{
		var jugadores = Minecraft.World.getPlayers();
		for(var j in jugadores){
			var jPosition = jugadores[j].location;
			var jX = Math.floor(jPosition.x);
			var jY = Math.floor(jPosition.y);
			var jZ = Math.floor(jPosition.z);
			var entitiesAtPlayers = Minecraft.World.getDimension("overworld").getEntitiesAtBlockLocation(new BlockLocation(jX,jY-1,jZ));
			for(var x in entitiesAtPlayers){
				if(entitiesAtPlayers[x].id == "minecraft:player"){
					var jpX = Math.floor(entitiesAtPlayers[x].location.x);
					var jpY = Math.floor(entitiesAtPlayers[x].location.y);
					var jpZ = Math.floor(entitiesAtPlayers[x].location.z);
					var blockAtEntities = Minecraft.World.getDimension("overworld").getBlock(new BlockLocation(jpX,jpY-2,jpZ)).getBlockData();
					var blockNameO = blockAtEntities.getType().getName();
					var blockPropertiesO = blockAtEntities.getAllProperties();
					var etiquetasBO = blockAtEntities.getTags();
					try{
						if(blockNameO !== undefined && (blockPropertiesO[0] === undefined && etiquetasBO[0] === undefined)){
				Minecraft.Commands.run(`titleraw @a[name="${entitiesAtPlayers[x].name}"] actionbar {"rawtext": [ {"text": "Name:§a ${blockNameO}\n§rProperty: None\nMainTag: No Tags\nDimension: §aOverworld"}]}`);
			}else if(blockNameO !== undefined && (blockPropertiesO[0] !== undefined && etiquetasBO[0] === undefined)){
				Minecraft.Commands.run(`titleraw @a[name="${entitiesAtPlayers[x].name}"] actionbar {"rawtext": [ {"text": "Name:§a ${blockNameO}\n§rProperty:§6 ${blockPropertiesO[0].name} §rValue:§6 ${blockPropertiesO[0].value}\n§rMainTag: No Tags\nDimension:§2 Overworld"}]}`);
			}else if(blockNameO !== undefined && (blockPropertiesO[0] === undefined && etiquetasBO[0] !== undefined)){
				Minecraft.Commands.run(`titleraw @a[name="${entitiesAtPlayers[x].name}"] actionbar {"rawtext": [ {"text": "Name:§a ${blockNameO}\n§rProperty: None\nMainTag:§9 ${etiquetasBO[0]}\n§rDimension:§2 Overworld"}]}`);
			}else if(blockNameO !== undefined && (blockPropertiesO[0] !== undefined && etiquetasBO[0] !== undefined)){
				Minecraft.Commands.run(`titleraw @a[name="${entitiesAtPlayers[x].name}"] actionbar {"rawtext": [ {"text": "Name:§a ${blockNameO}\n§rProperty:§6 ${blockPropertiesO[0].name} §rValue:§6 ${blockPropertiesO[0].value}\n§rMainTag:§9 ${etiquetasBO[0]}\n§rDimension:§2 Overworld"}]}`);
			}else{
				}
					}catch(error){}
					break;
				}
			}
		}
	}catch(error){}
	try{
		var players = Minecraft.World.getPlayers();
		for(var p in players){
			var pPosition = players[p].location;
			var pX = Math.floor(pPosition.x);
			var pY = Math.floor(pPosition.y);
			var pZ = Math.floor(pPosition.z);
			var entitiesAtPlayersN = Minecraft.World.getDimension("nether").getEntitiesAtBlockLocation(new BlockLocation(pX,pY-1,pZ));
			for(var n in entitiesAtPlayersN){
				if(entitiesAtPlayersN[n].id == "minecraft:player"){
					var npX = Math.floor(entitiesAtPlayersN[n].location.x);
					var npY = Math.floor(entitiesAtPlayersN[n].location.y);
					var npZ = Math.floor(entitiesAtPlayersN[n].location.z);
					var blockAtEntitiesN = Minecraft.World.getDimension("nether").getBlock(new BlockLocation(npX,npY-2,npZ)).getBlockData();
					var blockNameN = blockAtEntitiesN.getType().getName();
					var blockNameN = blockAtEntitiesN.getType().getName();
					var blockPropertiesN = blockAtEntitiesN.getAllProperties();
					var etiquetasBN = blockAtEntitiesN.getTags();
					try{
						if(blockNameN !== undefined && (blockPropertiesN[0] === undefined && etiquetasBN[0] === undefined)){
				Minecraft.Commands.run(`titleraw @a[name="${entitiesAtPlayersN[n].name}"] actionbar {"rawtext": [ {"text": "Name:§a ${blockNameN}\n§rProperty: None\nMainTag: No Tags\nDimension:§c Nether"}]}`);
			}else if(blockNameN !== undefined && (blockPropertiesN[0] !== undefined && etiquetasBN[0] === undefined)){
				Minecraft.Commands.run(`titleraw @a[name="${entitiesAtPlayersN[n].name}"] actionbar {"rawtext": [ {"text": "Name:§a ${blockNameN}\n§rProperty:§6 ${blockPropertiesN[0].name} §rValue:§6 ${blockPropertiesN[0].value}\n§rMainTag: No Tags\nDimension:§c Nether"}]}`);
			}else if(blockNameN !== undefined && (blockPropertiesN[0] === undefined && etiquetasBN[0] !== undefined)){
				Minecraft.Commands.run(`titleraw @a[name="${entitiesAtPlayersN[n].name}"] actionbar {"rawtext": [ {"text": "Name:§a ${blockNameN}\n§rProperty: None\nMainTag:§9 ${etiquetasBN[0]}\n§rDimension:§c Nether"}]}`);
			}else if(blockNameN !== undefined && (blockPropertiesN[0] !== undefined && etiquetasBN[0] !== undefined)){
				Minecraft.Commands.run(`titleraw @a[name="${entitiesAtPlayersN[n].name}"] actionbar {"rawtext": [ {"text": "Name:§a ${blockNameN}\n§rProperty:§6 ${blockPropertiesN[0].name} §rValue:§6 ${blockPropertiesN[0].value}\n§rMainTag:§9 ${etiquetasBN[0]}\n§rDimension:§c Nether"}]}`);
			}else{
				}
					}catch(error){}
					break;
				}
			}
		}
	}catch(error){}
	try{
		var playersF = Minecraft.World.getPlayers();
		for(var f in playersF){
			var fPosition = playersF[f].location;
			var fpX = Math.floor(fPosition.x);
			var fpY = Math.floor(fPosition.y);
			var fpZ = Math.floor(fPosition.z);
			var entitiesAtPlayersF = Minecraft.World.getDimension("the end").getEntitiesAtBlockLocation(new BlockLocation(fpX,fpY-1,fpZ));
			for(var end in entitiesAtPlayersF){
				if(entitiesAtPlayersF[end].id == "minecraft:player"){
					var pfX = Math.floor(entitiesAtPlayersF[end].location.x);
					var pfY = Math.floor(entitiesAtPlayersF[end].location.y);
					var pfZ = Math.floor(entitiesAtPlayersF[end].location.z);
					var blockAtEntitiesF = Minecraft.World.getDimension("the end").getBlock(new BlockLocation(pfX,pfY-2,pfZ)).getBlockData();
					var blockNameF = blockAtEntitiesF.getType().getName();
					var blockNameF = blockAtEntitiesF.getType().getName();
					var blockPropertiesF = blockAtEntitiesF.getAllProperties();
					var etiquetasBF = blockAtEntitiesF.getTags();
					try{
						if(blockNameF !== undefined && (blockPropertiesF[0] === undefined && etiquetasBF[0] === undefined)){
				Minecraft.Commands.run(`titleraw @a[name="${entitiesAtPlayersF[end].name}"] actionbar {"rawtext": [ {"text": "Name:§a ${blockNameF}\n§rProperty: None\nMainTag: No Tags\nDimension:§d The end"}]}`);
			}else if(blockNameF !== undefined && (blockPropertiesF[0] !== undefined && etiquetasBF[0] === undefined)){
				Minecraft.Commands.run(`titleraw @a[name="${entitiesAtPlayersF[end].name}"] actionbar {"rawtext": [ {"text": "Name:§a ${blockNameF}\n§rProperty:§6 ${blockPropertiesF[0].name} §rValue:§6 ${blockPropertiesF[0].value}\n§rMainTag: No Tags\nDimension:§d The end"}]}`);
			}else if(blockNameF !== undefined && (blockPropertiesF[0] === undefined && etiquetasBF[0] !== undefined)){
				Minecraft.Commands.run(`titleraw @a[name="${entitiesAtPlayersF[end].name}"] actionbar {"rawtext": [ {"text": "Name:§a ${blockNameF}\n§rProperty: None\nMainTag:§9 ${etiquetasBF[0]}\n§rDimension:§d The end"}]}`);
			}else if(blockNameF !== undefined && (blockPropertiesF[0] !== undefined && etiquetasBF[0] !== undefined)){
				Minecraft.Commands.run(`titleraw @a[name="${entitiesAtPlayersF[end].name}"] actionbar {"rawtext": [ {"text": "Name:§a ${blockNameF}\n§rProperty:§6 ${blockPropertiesF[0].name} §rValue:§6 ${blockPropertiesF[0].value}\n§rMainTag:§9 ${etiquetasBF[0]}\n§rDimension:§d The end"}]}`);
			}else{
				}
					}catch(error){}
					break;
				}
			}
		}
	}catch(error){}
	}
}); 